-- ModMagicNumbersFileAdd("mods/AdventureMode/files/magic_numbers.xml")

--Adding Custom Translations
local contents = ModTextFileGetContent("data/translations/common.csv")
local languages = { "en", "ru", "pt-br", "es-es", "de", "fr-fr", "it", "pl", "zh-cn", "jp", "k", }

function add_translation_string(id, translations)
  contents = contents .. id .. ","
  for i, language in ipairs(languages) do
    if translations[language] then
      contents = contents .. "\"" .. translations[language]:gsub("\n", "\\n") .. "\","
    else
      contents = contents .. ","
    end
  end
  contents = contents .. ",,,\n"
end

--Please notice how dialogues have special spacing with several spaces and a couple of enters. This is important
--Normal names do not have that special spacing (If you don't understand it well, I can fix it later)

add_translation_string("adventure_mode_slab_interact1", {
  en = [[
    {@delay 2}The secrets to manipulating life and the universe itself
    lie in these halls, waiting for those who are worthy.{@pause 30}
    If you want to be given everything, give everything up.
  ]],
  jp = [[
    {@delay 2}万物をつかさどる力は
    選ばれし者にのみ与えられる。{@pause 30}
    この先へと進みたくば  全てを捨てよ。
  ]],
  ru = [[
    {@delay 2}Секреты управления жизнью и самой вселенной
    лежат в этих залах, ожидая тех, кто достоин.{@pause 30}
    Если вы хотите, чтобы вам дали все, откажитесь от
    всего.
  ]]
})

add_translation_string("adventure_mode_slab_gem_hand_interact1", {
  en = [[
    {@delay 2}Always in a hurry, rushing towards your goal
    yet making no progress. Stop and focus on your current
    desires. Then your problems will solve themselves.
  ]],
  jp = [[
    {@delay 2}急がば回れ。拙速の先に道はなし。
    立ち止まり  己の望みを見つめ直せ。
    さすれば道は自ずと開かれるであろう。
  ]],
  ru = [[
    {@delay 2}Всегда в спешке, мчитесь к своей цели
    но безуспешно. Остановитесь и думайте о своих текущих
    желаниях. Тогда ваши проблемы решатся сами собой.
  ]]
})

add_translation_string("adventure_mode_slab_name", {
  en = [[Ancient tablet]],
  jp = [[いにしえの碑文]],
  ru = [[Древняя таблица]]
})

add_translation_string("adventure_mode_skeleton_name", {
  en = [[Skeleton]],
  jp = [[探求者の屍]],
  ru = [[Скелет]]
})

add_translation_string("adventure_mode_interact_command", {
  en = [[Press $0 to interact]],
  jp = [[$0 を押して調べる]],
  ru = [[Нажмите $0 чтобы взаимодействовать]]
})

add_translation_string("adventure_mode_read_command", {
  en = [[Press $0 to read]],
  jp = [[$0 を押して読む]],
  ru = [[Нажмите $0 чтобы прочесть]]
})

add_translation_string("adventure_mode_skeleton_interact1", {
  en = [[
    Yoo what?! You have #TWO# arms?{@delay 30}...{@delay 3} Bruh!{@pause 30}
    Back in my day we only had one arm
    when holding no items!
  ]],
  jp = [[
    #オマエ  ウデガ  フタツモ  アルノカ！？#{@delay 30}...{@delay 3}ハァ...{@pause 30}
    ムカシノ  バージョンデハ
    ニンゲンハ  アイテムヲ  モッテナイト
    カタウデ  ダケダッタンダゼ...
  ]],
  ru = [[
    Стой, что?! У тебя #ДВЕ# руки?{@delay 30}...{@delay 3} Чел!{@pause 30}
    Вот в наше время у нас была только одна рука
    когда не держали предмет!
  ]]
})

add_translation_string("adventure_mode_skeleton_interact2", {
  en = [[
    This is too hard man...
    I chose to give up and starve to death instead ~LMAO~.
  ]],
  jp = [[
    オイラハ  ココデ  アキラメヨウカナ...
  ]],
  ru = [[
    Это слишком тяжело...
    Вместо этого я решил сдаться и умереть с голоду ~ЛОЛ~.
  ]]
})

add_translation_string("adventure_mode_skeleton_interact3", {
  en = [[
    At least I made it farther than that other loser. #LOL#
  ]],
  jp = [[
    #ケケケッ！#  ウシロノ  アイツハ  「ザコ」ダナ！
    オレサマノ  ホウガ  サキマデ  ススメタゼ！  #ケタケタケタ...#
  ]],
  ru = [[
    Ну, хотя бы я добрался дальше, чем тот неудачник. #ЛОЛ#
  ]]
})

add_translation_string("adventure_mode_skeleton_interact4", {
  en = [[
    Maybe I shouldn't have gone into this maze without a torch...
  ]],
  jp = [[
    アンタモ  メイロニハ\n「タイマツ」ヲ  モッテキタ  ホウガ  イイゼ？
  ]],
  ru = [[
    Возможно не стоило сюда соваться без факела...
  ]]
})

add_translation_string("adventure_mode_skeleton_interact5", {
  en = [[
    Yo what?! You can burn this with fire?{@delay 30}...{@delay 3} Dang!{@pause 30}
    I told him we should've brought a torch...
  ]],
  jp = [[
    エッ！？  「タイマツ」デ  モヤシタ！？{@delay 30}...{@pause 30}
    アニキ...{@delay 3}  オイラノ  イッタトオリ  ジャンカ...
  ]],
  ru = [[
    Эй что?! Это можно сжечь?{@delay 30}...{@delay 3} Чёрт!{@pause 30}
    Я же говорил, что надо было взять факел...
  ]]
})

add_translation_string("adventure_mode_skeleton_interact6", {
  en = [[
    Wait{@delay 30}...{@delay 3} How did we even get here?
  ]],
  jp = [[
    オマエ{@delay 30}...{@delay 3}  ナンデ  イキテルンダ？
  ]],
  ru = [[
    Подожди-ка{@delay 30}...{@delay 3} Как мы вообще сюда попали?
  ]]
})

add_translation_string("adventure_mode_golem_sleeping_name", {
  en = [[Strange Statue]],
  jp = [[不思議な石像]],
  ru = [[Странная Статуя]]
})

add_translation_string("adventure_mode_golem_sleeping_interact", {
  en = [[
    An old statue lies on the floor, it looks broken.
  ]],
  jp = [[
    石像だ。長い年月を経たためか、崩れかかっている。
  ]],
  ru = [[
    На полу лежит старая статуя, она выглядит сломанной.
  ]]
})

add_translation_string("adventure_mode_golem_insert_gemstone", {
  en = [[Insert Gemstone]],
  jp = [[額に宝石を入れる]],
  ru = [[Вставить драгоценный камень]]
})

add_translation_string("adventure_mode_golem_name", {
  en = [[Golem]],
  jp = [[ゴーレム]],
  ru = [[Голем]]
})

add_translation_string("adventure_mode_golem_interact1", {
  en = [[
    {@delay 4}Were you the one who woke me from my slumber?{@pause 60}
    Another seeker of magic?{@pause 20} Ah, who else would it be...{@pause 30}
    I wonder if this one is going to finally make it?
  ]],
  jp = [[
    {@delay 4}グゴゴゴ...{@pause 20}  誰ダ  ワシノ眠リヲ  妨ゲルモノハ...{@pause 60}
    フム  オヌシモ 「力」ガ  欲シイノカ？{@pause 20}
    オヌシ如キニ  「試練」ヲ  乗リ越エラレルノカ？
  ]],
  ru = [[
    {@delay 4}Это ты пробудил меня?{@pause 60}
    Еще один искатель магии?{@pause 20} А, кто бы это еще мог быть...{@pause 30}
    Интересно, справится ли этот?
  ]]
})

add_translation_string("adventure_mode_golem_mina_response1", {
  en = [[Who created you?]],
  jp = [[キミを作ったのは誰？]],
  ru = [[Кто тебя создал?]]
})

add_translation_string("adventure_mode_golem_interact2", {
  en = [[
    {@delay 4}Well, you see{@pause 15}.{@pause 15}.{@pause 15}. {@pause 15}
    When a mommy stone and a daddy stone
    love each other very much...
  ]],
  jp = [[
    {@delay 4}ナヌッ！？ソレハダナ{@pause 15}.{@pause 15}.{@pause 15}. {@pause 15}
    ヨイカ？  愛シ合ウ  二人ノ元ニハ
    「コウノトリ」ガ...
  ]],
  ru = [[
    {@delay 4}Хм, видишь ли{@pause 15}.{@pause 15}.{@pause 15}. {@pause 15}
    Когда мама-камень и папа-камень
    очень любят друг друга...
  ]]
})

add_translation_string("adventure_mode_golem_mina_response2", {
  en = [[Spare me the rest...]],
  jp = [[......]],
  ru = [[Хватит...]]
})

add_translation_string("adventure_mode_golem_mina_response3", {
  en = [[Can you break the wall for me?]],
  jp = [[そこの壁を壊して欲しい]],
  ru = [[Можешь сломать для меня стену?]]
})

add_translation_string("adventure_mode_golem_interact3", {
  en = [[
    {@delay 4}Nothing easier than that. Step aside and watch me go. 
  ]],
  jp = [[
    {@delay 4}容易イコトダ。  ソコデ  待ッテオレ...
  ]],
  ru = [[
    {@delay 4}Нет ничего проще. Отойди и увидишь!
  ]]
})

add_translation_string("adventure_mode_golem_interact_end", {
  en = [[End]],
  jp = [[立ち去る]],
  ru = [[Конец]]
})

add_translation_string("adventure_mode_golem_interact4", {
  en = [[
    You may now pass.
  ]],
  jp = [[
    一丁上ガリ  ダ...
  ]],
  ru = [[
    Теперь ты можешь пройти.
  ]]
})

add_translation_string("adventure_mode_golem_interact_leave", {
  en = [[Leave]],
  jp = [[立ち去る]],
  ru = [[Уйти]]
})

add_translation_string("adventure_mode_golem_mina_response4", {
  en = [[Do you think I will make it?]],
  jp = [[「試練」は難しい？]],
  ru = [[Ты думаешь я справлюсь?]]
})

add_translation_string("adventure_mode_golem_interact5", {
  en = [[
    {@delay 4}It's quite intriguing how you seek such
    power and wealth.{@pause 40}
    {@delay 5}It's unwise to pursue such things.
    {@pause 20}Unless you want to suffer for it.
  ]],
  jp = [[
    {@delay 4}興味深イナ...  ソレホドマデニ
    「力」ガ  欲シイカ。{@pause 40}
    {@delay 5}...覚悟ナキ者ニハ  決シテ  乗リ越エラレヌ。
    {@pause 20}ソレダケハ  教エテオコウ...
  ]],
  ru = [[
    {@delay 4}Удивительно, как вы жаждите такой
    власти и богатства.{@pause 40}
    {@delay 5}Неразумно добиваться таких вещей.
    {@pause 20}Если только не хотите ради них страдать.
  ]]
})

add_translation_string("adventure_mode_golem_interact6", {
  en = [[
    {@delay 6}Mmmm donuts...
  ]],
  jp = [[
    {@delay 6}「ドーナツ」  食ベタイナ...
  ]],
  ru = [[
    {@delay 6}Ммм пончики...
  ]]
})

add_translation_string("adventure_mode_golem_interact7", {
  en = [[
    {@delay 4}You're still waiting for answers?{@pause 30}
    I served my purpose,{@pause 20} there is nothing more
    I can do for you at my state.
  ]],
  jp = [[
    {@delay 4}マダ  何カ  頼ミガ  アルノカ？{@pause 30}
    スマナイガ  今ノ  ワシニ  デキルコトハ
    壁ヲ  壊スコトダケダ...{@pause 20}  ムニャムニャ...
  ]],
  ru = [[
    {@delay 4}Вы все еще ждете ответов?{@pause 30}
    Я выполнил свою задачу,{@pause 20} Ничем больше 
    я вам не могу помочь в моем состоянии.
  ]]
})

add_translation_string("adventure_mode_sign_name", {
  en = [[Sign]],
  jp = [[古い書き置き]],
  ru = [[Знак]]
})

add_translation_string("adventure_mode_sign_interact", {
  en = [[
    {@delay 2}Keep possession of your items, avoid throwing them in 
    unreachable areas such as the poison {@pause 30} ...{@pause 30}
    Think before you throw.
  ]],
  jp = [[
    {@delay 2}ここまでたどり着いた者へ。
    手元には気を付けろ。{@pause 30}毒や溶岩の中に
    物を落としたら、取り戻すことはできないぞ。
  ]],
  ru = [[
    {@delay 2}Берегите свои вещи, не бросайте их в
    недоступные места, например в яд {@pause 30} ...{@pause 30}
    Думайте, прежде чем бросать.
  ]]
})

add_translation_string("adventure_mode_jetpack", {
  en = [[Gift Of Flight]],
  jp = [[浮遊のアーティファクト]],
  ru = [[Дар Полета]]
})

add_translation_string("adventure_mode_pickup1", {
  en = [[You gained the Gift Of Flight]],
  jp = [[空を飛ぶ力を手に入れた]],
  ru = [[Вы получили Gift Of Flight]]
})

add_translation_string("adventure_mode_jetpack2", {
  en = [[Levitation Boost]],
  jp = [[飛翔の秘儀]],
  ru = [[Усиленный полет]]
})

add_translation_string("adventure_mode_pickup2", {
  en = [[You gained Levitation Boost]],
  jp = [[より長い時間空を飛べるようになった]],
  ru = [[Вы получили Усиленный полет]]
})

add_translation_string("adventure_mode_wand_powerup", {
  en = [[Wand Powerup]],
  jp = [[魔力の秘宝]],
  ru = [[Усиление жезла]]
})

add_translation_string("adventure_mode_pickup3", {
  en = [[You gained a wand boost]],
  jp = [[魔法の杖が力を増した]],
  ru = [[Вы получили усиление жезла]]
})

add_translation_string("adventure_mode_save_statue", {
  en = [[Press $0 to save your progress]],
  jp = [[$0 を押してセーブ]],
  ru = [[Нажмите $0 чтобы сохраниться]]
})


add_translation_string("adventure_mode_save_point", {
  en = [[Progress saved, respawn point set]],
  jp = [[セーブ完了。リスポーン地点が設定された。]],
  ru = [[Прогресс сохранен, точка возрождения установлена]]
})

add_translation_string("adventure_mode_teleporter1", {
  en = [[Teleport to levers]],
  jp = [[レバーの部屋へ]],
  ru = [[Телепорт к рычагам]]
})

add_translation_string("adventure_mode_teleporter2", {
  en = [[Teleport behind gunpowder door]],
  jp = [[燃える門の先へ]],
  ru = [[Телепорт за дверь с порохом]]
})

add_translation_string("adventure_mode_teleporter3", {
  en = [[Teleport to Sauva mistress]],
  jp = [[女神の部屋へ]],
  ru = [[Телепорт к госпоже Sauva]]
})

add_translation_string("adventure_mode_teleporter_back", {
  en = [[Portal to warp room]],
  jp = [[ポータルの部屋へ戻る]],
  ru = [[Портал в комнату телепортации]]
})

add_translation_string("adventure_mode_teleporter_ending", {
  en = [[UNSTABLE TRANS-DIMENSIONAL PORTAL]],
  jp = [[異世界への門]],
  ru = [[НЕСТАБИЛЬНЫЙ ПОРТАЛ В ДРУГИЕ ИЗМЕРЕНИЯ]]
})

add_translation_string("adventure_mode_gem", {
  en = [[Red Glowing Gemstone]],
  jp = [[赤い宝石]],
  ru = [[Красный сияющий драгоценный камень]]
})

add_translation_string("adventure_mode_gem_desc", {
  en = [[A red gemstone. It is giving off a bright red light.]],
  jp = [[赤い宝石だ。明るく輝いている。]],
  ru = [[Красный драгоценный камень. Ярко светится красным.]]
})

add_translation_string("adventure_mode_heatstroke", {
  en = [[Heatstroke]],
  jp = [[熱中症]],
  ru = [[Тепловой удар]]
})

add_translation_string("adventure_mode_heatstroke_desc", {
  en = [[You don't feel so good...]],
  jp = [[気分が悪い。]],
  ru = [[Вы не очень хорошо себя чувствуете...]]
})

add_translation_string("adventure_mode_camel_meat", {
  en = [[Camel Meat]],
  jp = [[ラクダの肉]],
  ru = [[Мясо верблюда]]
})

add_translation_string("adventure_mode_sadness", {
  en = [[Sadness]],
  jp = [[悲しみ]],
  ru = [[Грусть]]
})

add_translation_string("adventure_mode_sadness_desc", {
  en = [[Tastes like a dead friend... *sniff*]],
  jp = [[友との別れの味は、少しほろ苦い。]],
  ru = [[На вкус как мертвый друг... *всхлип*]]
})

add_translation_string("adventure_mode_noita_meat", {
  en = [[Noita]],
  jp = [[ミナ]],
  ru = [[Ноита]]
})

add_translation_string("adventure_mode_cannibalism", {
  en = [[Cannibalism]],
  jp = [[カニバリズム]],
  ru = [[Каннибализм]]
})

add_translation_string("adventure_mode_cannibalism_desc", {
  en = [[Did... I just eat myself?!?\n... Hey, I taste pretty good!]],
  jp = [[自分の死体を食べた。\n...けっこうおいしい。]],
  ru = [[Неужели... Я только что съел себя?!?\n... Эй, а я вполне вкусный!]]
})

add_translation_string("adventure_mode_levitation_refresh", {
  en = [[Levitate Juiceboost]],
  jp = [[浮遊リフレッシャー]],
  ru = [[Пополнение левитации]]
})

add_translation_string("adventure_mode_torch", {
  en = [[Charred stick]],
  jp = [[ひのきの棒]],
  ru = [[Обугленная палка]]
})

add_translation_string("adventure_mode_torch_desc", {
  en = [[A charred stick?! What kind of reward is this?!]],
  jp = [[先端が焦げた棒。間違いなく宝物ではない。]],
  ru = [[Обугленная палка?! Что это за награда?!]]
})

add_translation_string("adventure_mode_torch_ignited", {
  en = [[Torch]],
  jp = [[松明]],
  ru = [[Факел]]
})

add_translation_string("adventure_mode_torch_ignited_desc", {
  en = [[Portable fire]],
  jp = [[松明だ。辺りを照らすことができる。]],
  ru = [[Переносной огонь]]
})

add_translation_string("adventure_mode_torch_extinguished_desc", {
  en = [[Once a glorious torch, now no more than a paltry stick...\nCould it be restored to its former glory?]],
  jp = [[燃え盛る炎もいずれ消え果てる。\nかつての光は取り戻されるのだろうか？]],
  ru = [[Это был славный факел, теперь же — ничтожная палка...\nМожно ли ему вернуть былую славу?]]
})

add_translation_string("adventure_mode_brittle_gravel", {
  en = [[Brittle Gravel]],
  jp = [[もろい岩]],
  ru = [[Хрупкий камень]]
})

add_translation_string("adventure_mode_impermeable_slime", {
  en = [[Impermeable Slime]],
  jp = [[撥水スライム]],
  ru = [[Водонепроницаемая слизь]]
})

add_translation_string("adventure_mode_lever", {
  en = [[Press $0 to activate]],
  jp = [[$0 で切り替える]],
  ru = [[Нажмите $0 для активации]]
})

add_translation_string("adventure_mode_sacrifice", {
  en = [[Press $0 to sacrifice yourself]],
  jp = [[$0 で瞑想する]],
  ru = [[Нажмите $0 чтобы принести себя в жертву]]
})


ModTextFileSetContent("data/translations/common.csv", contents)

ModLuaFileAppend("data/scripts/status_effects/status_list.lua", "mods/AdventureMode/files/status_list_append.lua")
ModMaterialsFileAdd("mods/AdventureMode/files/materials.xml")
ModRegisterAudioEventMappings("mods/AdventureMode/files/audio/GUIDs.txt")
dofile_once("mods/AdventureMode/lib/DialogSystem/init.lua")("mods/AdventureMode/lib/DialogSystem", {
  disable_controls = true,
  sounds = {
    bones = { bank = "mods/AdventureMode/files/audio/AdventureMode.bank", event = "bones_rattle" },
    stone = { bank = "mods/AdventureMode/files/audio/AdventureMode.bank", event = "golem_speak" },
  }
})
dofile_once("mods/AdventureMode/lib/coroutines.lua")
dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/AdventureMode/files/util.lua")
local nxml = dofile_once("mods/AdventureMode/lib/nxml.lua")

-- Overwrite death sound to disable it
GamePlaySound("mods/AdventureMode/files/audio/death.bank", "dummy_sound", 0, 0)

--set collapsed concrete strength
local content = ModTextFileGetContent("data/materials.xml")
local xml = nxml.parse(content)
for element in xml:each_child() do
  if element.attr.name == "concrete_collapsed" then
    element.attr.durability = 5000
  end
end
ModTextFileSetContent("data/materials.xml", tostring(xml))

--add custom materials
ModMaterialsFileAdd("mods/AdventureMode/files/materials/materials.xml")

local content = ModTextFileGetContent("data/biome/_biomes_all.xml")
local xml = nxml.parse(content)
xml:add_children(nxml.parse_many([[
<Biome
  biome_filename="mods/AdventureMode/files/biomes/desert.xml" 
  height_index="0"
  color="ffc1ab5b">
</Biome>
<Biome
  biome_filename="mods/AdventureMode/files/biomes/sand.xml" 
  height_index="0"
  color="ff877531">
</Biome>
<Biome
  biome_filename="mods/AdventureMode/files/biomes/dark.xml" 
  height_index="0"
  color="ff282620">
</Biome>
<Biome
  biome_filename="mods/AdventureMode/files/biomes/pyramid.xml" 
  height_index="0"
  color="ffec2b42">
</Biome>
<Biome
  biome_filename="mods/AdventureMode/files/biomes/golem_room.xml" 
  height_index="0"
  color="ff986b4f">
</Biome>
]]))
ModTextFileSetContent("data/biome/_biomes_all.xml", tostring(xml))

local starting_positions = {
  { x = 150, y = -768 }, -- 1 Intro
  { x = 715, y = -600 }, -- 2 In front of Main door
  { x = 1057, y = -553 }, -- 3 Tablet
  { x = 1173, y = -553 }, -- 4 Lava room
  { x = 1341, y = -891 }, -- 5 Electricity door room
  { x = 1412, y = -895 }, -- 6 Pressure plate puzzle
  { x = 1722, y = -910 }, -- 7 Spike corridor
  { x = 2450, y = -910 }, -- 8 Golem
  { x = 2138, y = -844 }, -- 9 After spike corridor
  { x = 1290, y = -285 }, -- 10 Lever puzzle
  { x = 2203, y = -910 }, -- 11 Brazier
  { x = 2735, y = -625 }, -- 12 Teleporter room
  { x = 3054, y = -870 }, -- 13 Water
  { x = 4444, y = -103 }, -- 14 Lever puzzle
  { x = 3460, y = -1179}, -- 15 Golem
  { x = 3817, y = -1171 }, -- 16 Hand with gem
  { x = 4400, y = -1020 }, -- 17 Lever door maze
  { x = 5560, y = -668 }, -- 18 Wand Mistress
  { x = 3874, y = -864 }, -- 19 Water area, alligator testing
  { x = 5669, y = 412 }, -- 20 Rebirth Room
  { x = 3814, y = -1000 }, -- 21 Gate Opener Puzzle
  { x = 6055, y = -893 }, -- 22 Poison Challenge
  { x = 2747, y = -1514 }, -- 23 rising lava Challenge
}
local starting_position = 1

ModTextFileSetContent("mods/AdventureMode/_virtual/magic_numbers.xml", string.format([[
<MagicNumbers
  DESIGN_PLAYER_START_POS_X="%d"
  DESIGN_PLAYER_START_POS_Y="%d"
  ></MagicNumbers>
  ]], starting_positions[starting_position].x, starting_positions[starting_position].y))
  
  -- DEBUG_MATERIAL_AREA_CHECKER="1"
  -- DEBUG_COLLISION_TRIGGERS="1"
ModMagicNumbersFileAdd("mods/AdventureMode/_virtual/magic_numbers.xml")

-- ModLuaFileAppend("data/scripts/gun/gun_actions.lua", "mods/AdventureMode/files/gun_actions_append.lua")

function OnPlayerSpawned(player)

  local x, y = EntityGetTransform(player)
  
  if starting_position == 23 then
	EntityLoad("mods/AdventureMode/files/pickups/jetpack2.xml", x, y)
  end

  EntitySetDamageFromMaterial( player, "poison_permanent", 0.01 )
  
  GlobalsSetValue("AdventureMode_DEBUG_starting_position", starting_position)
  
  if GlobalsGetValue("AdventureMode_player_initialized", "0") == "0" then
    GlobalsSetValue("AdventureMode_player_initialized", "1")
    if starting_position == 1 then
      EntityLoad("mods/AdventureMode/files/intro.xml")
    else
      GlobalsSetValue("AdventureMode_respawn_x", starting_positions[starting_position].x)
      GlobalsSetValue("AdventureMode_respawn_y", starting_positions[starting_position].y)
	  
	  local world_state = GameGetWorldStateEntity()
	  EntityAddComponent(world_state, "LuaComponent", {
		  script_source_file="mods/AdventureMode/files/music_player.lua",
		  execute_every_n_frame=1,
		  execute_on_added=1
	  })
	  
    end
    local world_state_entity = GameGetWorldStateEntity()
    local world_state_component = EntityGetFirstComponentIncludingDisabled(world_state_entity, "WorldStateComponent")
    ComponentSetValue2(world_state_component, "intro_weather", true)
    ComponentSetValue2(world_state_component, "time", 1)
    ComponentSetValue2(world_state_component, "fog", 0)
    ComponentSetValue2(world_state_component, "fog_target", 0)
    ComponentSetValue2(world_state_component, "sky_sunset_alpha_target", 0.5)
    ComponentSetValue2(world_state_component, "gradient_sky_alpha_target", 0.5)
  
    -- Remove crown etc
    local sprite_tags = {
      "player_hat2",
      "player_hat2_shadow",
      "player_hat",
      "player_amulet_gem",
      "player_amulet",
      "lukki_enable",
    }
    for i, tag in ipairs(sprite_tags) do
      local comp = EntityGetFirstComponentIncludingDisabled(player, "SpriteComponent", tag)
      EntityRemoveComponent(player, comp)
    end

    -- Disable jetpack
    if starting_position > 1 then
      entity_set_component_value(player, "CharacterDataComponent", "fly_time_max", 1)
    else
      entity_set_component_value(player, "CharacterDataComponent", "fly_time_max", 0)
    end
    entity_set_component_value(player, "CharacterDataComponent", "fly_recharge_spd", 0.2)
    entity_set_component_value(player, "CharacterDataComponent", "fly_recharge_spd_ground", 1.0)
  
    -- Make immortal
    entity_set_component_value(player, "DamageModelComponent", "wait_for_kill_flag_on_death", true)
    EntityAddComponent2(player, "LuaComponent", {
      script_source_file = "mods/AdventureMode/files/player_lethal_damage_watcher.lua",
      script_damage_received = "mods/AdventureMode/files/player_lethal_damage_watcher.lua",
      execute_every_n_frame=-1,
      execute_on_added=true,
      enable_coroutines=true,
    })
  
    -- Prepare Inventory
    local inventory_quick = EntityGetWithName("inventory_quick")
    local items = EntityGetAllChildren(inventory_quick) or {}
    for i, item in ipairs(items) do
      EntityKill(item)
    end
    local water_potion = EntityLoad("data/entities/items/pickup/potion_water.xml")
    AddMaterialInventoryMaterial(water_potion, "water", 300)
    EntityAddChild(inventory_quick, water_potion)
    -- GamePickUpInventoryItem(player, water_potion, false)
  
    -- Add no-item-arm
    EntityAddComponent2(player, "SpriteComponent", {
      _tags="right_arm_root,character",
      image_file="data/enemies_gfx/player_arm_no_item.xml",
      z_index=0.59
    })
    -- local torch = EntityLoad("mods/AdventureMode/files/torch.xml")
    -- GamePickUpInventoryItem(player, torch, false)
  
  
    -- EntityAddChild(inventory_quick, water_potion)
    -- EntityAddChild(inventory_quick)
    -- EntityKill(items[1])
    -- EntityKill(items[2])
  
  
    -- ComponentSetValue2(world_state_component, "", 2)
    -- camera_tracking_shot(260, -800, 260, -600, 0.01)
  end
end

function handle_arm_sprite()
  local respawn_in_progress = GlobalsGetValue("AdventureMode_respawn_in_progress", "0") == "1"
  local arm_r_entity = EntityGetWithName("arm_r")
  if not respawn_in_progress and arm_r_entity > 0 then
    local inventory_quick = EntityGetWithName("inventory_quick")
    local items = EntityGetAllChildren(inventory_quick)
    local sprite_component = EntityGetFirstComponentIncludingDisabled(arm_r_entity, "SpriteComponent")
    local active_item = get_active_item()
    -- Check if active item still exists, if EntityGetTransform returns nil then it doesn't
    local x = EntityGetTransform(active_item)
    local active_item_exists = x ~= nil
    local show_arm = not items or not active_item_exists
    local player = EntityGetWithTag("player_unit")[1]
    local no_item_arm_sprite_component = EntityGetFirstComponentIncludingDisabled(player, "SpriteComponent", "right_arm_root")
    ComponentSetValue2(no_item_arm_sprite_component, "alpha", show_arm and 1 or 0)
    EntitySetComponentIsEnabled(arm_r_entity, sprite_component, not show_arm)
  end
end

local debug_menu_open = false

function OnWorldPreUpdate()
  dofile("mods/AdventureMode/files/heatstroke_watcher.lua")
  local id = 2
  local function new_id()
    id = id + 1
    return id
  end
  gui = gui or GuiCreate()
  GuiStartFrame(gui)

  -- if GuiButton(gui, new_id(), 2, 200, "D") then
    -- debug_menu_open = not debug_menu_open
  -- end

  if debug_menu_open then
    GuiLayoutBeginVertical(gui, 1, 20)
    local inventory_quick = EntityGetWithName("inventory_quick")
    local player = EntityGetWithTag("player_unit")[1]
    if GuiButton(gui, new_id(), 0, 0, "Give torch") then
      local item = EntityLoad("mods/AdventureMode/files/torch.xml")
      GamePickUpInventoryItem(player, item, false)
    end
    if GuiButton(gui, new_id(), 0, 0, "Give rock") then
      local item = EntityLoad("data/entities/items/pickup/physics_gold_orb_greed.xml")
      GamePickUpInventoryItem(player, item, false)
    end
    if GuiButton(gui, new_id(), 0, 0, "Give gem") then
      local item = EntityLoad("mods/AdventureMode/files/gem_item.xml")
      GamePickUpInventoryItem(player, item, false)
    end
    if GuiButton(gui, new_id(), 0, 0, "Die") then
      local player = EntityGetWithTag("player_unit")[1]
      EntityInflictDamage(player, 999, "DAMAGE_MELEE", "", "NORMAL", 0, 0)
    end
    if GuiButton(gui, new_id(), 0, 0, "Ending teleport") then
      dofile_once("mods/AdventureMode/files/ending_portal.lua")
      local player = EntityGetWithTag("player_unit")[1]
      if player then
        do_teleport(player)
      end
    end
    if GuiButton(gui, new_id(), 0, 0, "Reload world") then
      BiomeMapLoad_KeepPlayer("data/biome_impl/biome_map.png")
    end
    if GuiButton(gui, new_id(), 0, 0, "Spawn brazier") then
      local player = EntityGetWithTag("player_unit")[1]
      if player then
        local x, y = EntityGetTransform(player)
        EntityLoad("mods/AdventureMode/files/brazier.xml", x, y)
      end
    end
    if GuiButton(gui, new_id(), 0, 0, "Bones rattling") then
      GamePlaySound("mods/AdventureMode/files/audio/AdventureMode.bank", "bones_rattle", 0, 0)
    end
    if GuiButton(gui, new_id(), 0, 0, "Rattle me bones!") then
      GamePlaySound("mods/AdventureMode/files/audio/AdventureMode.bank", "rattle_me_bones", 0, 0)
    end
    if not old_pos then
      if GuiButton(gui, new_id(), 0, 0, "Teleport far away") then
        local player = EntityGetWithTag("player_unit")[1]
        local x, y = EntityGetTransform(player)
        
        EntitySetTransform(player, x - 100000, y - 100000)
        old_pos = { x = x, y = y }
      end
    else
      if GuiButton(gui, new_id(), 0, 0, "Teleport back") then
        local player = EntityGetWithTag("player_unit")[1]
        EntitySetTransform(player, old_pos.x, old_pos.y)
        old_pos = nil
      end
    end
    GuiLayoutEnd(gui)
  end

  local number = #EntityGetWithTag("test")
  local number_last_frame = tonumber(GlobalsGetValue("number", "0"))
  if number ~= number_last_frame then
    print(("========== CHANGED from (%d) to (%d) =========="):format(number_last_frame, number))
    GamePrint("CHANGED")
    GlobalsSetValue("number", number)
  end

  -- Make sure arm doesn't hang weirdly without items
  handle_arm_sprite()
end
